/* 	$Id: pktkill.c 1.2 1996/05/31 13:25:50 kosa Exp kosa $	 */
/*	$Log: pktkill.c $
/*	Revision 1.2  1996/05/31 13:25:50  kosa
/*	enh log messages
/*	 */

#ifndef lint
static char vcid[] = "$Id: pktkill.c 1.2 1996/05/31 13:25:50 kosa Exp kosa $";
#endif /* lint */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <alloc.h>
#include <time.h>
#include "pktfmt.h"

/* #define DEBUG */

#define MAX_MSGLEN 30000
#define MAX_KILLENTRIES 100

unsigned cumul=0;

struct tagKillEntry {

  char *area;
  char *what;
  int flag;
};

typedef struct tagKillEntry KillEntry;

KillEntry kill[100];
int how_many=0;

void ProcessCfg(char *path)
{
  FILE *f;
  char temp[255], *what, *area;
  int i,line;

  if (!(f=fopen(path,"rt"))) {
    perror (path);
    exit(1);
  };
  line=1;
  how_many=0;
  while (fgets(temp,79,f)) {
    what=NULL;
    if (*(temp+strlen(temp)-1)=='\n') *(temp+strlen(temp)-1)='\0';
    if (temp[0]!=';') {
      switch (*temp) {
      case 'f':
        kill[how_many].flag=0; break;
      case 't':
        kill[how_many].flag=1; break;
      case 's':
        kill[how_many].flag=2; break;
      case 'F':
        kill[how_many].flag=3; break;
      case 'T':
        kill[how_many].flag=4; break;
      case 'S':
        kill[how_many].flag=5; break;
      case 'N':
        kill[how_many].flag=6; break;
      case 'A':
        kill[how_many].flag=7; break;
           
      default:
        fprintf (stderr,"\nFirst letter must be in [ftsFTSNA] in line %d of %s\n",line,path);
        exit(1);
      };
      area=temp+2;
      for (i=0;i<strlen(area);i++)
        if (*(area+i)=='/') {
          what=(area+i+1);
          *(area+i)=0;
        };
      if (!what) {
        fprintf(stderr,"\nNo '/' in line %d of %s\n",line,path);
        exit(1);
      };
      kill[how_many].area=(char *)malloc(strlen(area)+1);
      strcpy(kill[how_many].area,strupr(area));
      kill[how_many].what=(char *)malloc(strlen(what)+1);
      strcpy(kill[how_many].what,strupr(what));
      how_many++;
    };
    line++;
  };
  fclose(f);
};

int fileexists(char *path)
{
  FILE *f;
  f=fopen(path,"rb");
  if (f) fclose(f);
  return (f!=NULL);
};

int UntilNull (char *buffer, unsigned maxsize, FILE *f)
{
  int i;
  unsigned count;
  count=0;
  do {
    i=fgetc(f);
    *(buffer+count)=i;
    count++;
    if (i==0) break;
  } while ((i!=EOF) && (count<=maxsize));

  if (i==0) return 0; else if (i==EOF) {
    perror ("\nunexpected eof");
    exit (1);
  } else if (count>=maxsize) return 1;
  return 0;
};

void padblank(char *buffer, int maxlen)
{
  int  i;

  for (i=strlen(buffer);i<maxlen;i++) *(buffer+i)=0;
  return;
};


char *time_now(void)
{
  time_t now;
  char *asct;
   
  time(&now);
  asct=asctime(localtime(&now));
  asct[strlen(asct)-1]=0;
   
  return asct;
};

int main(int argc, char *argv[])
{
  char temp[255],From[40],To[40],Subject[80],fname[80];
  char *buffer, *pos, tempname[13],area[80];
  char uFrom[40],uTo[40],uSubject[80];
  unsigned i,pisi,msgcnt,killed;
  int multi,isarea,rule,never,nonoarea;
  clock_t t;

  PKTHEADER header;
  MSGHEADER msghdr;
  FILE *f,*g,*h;

  msgcnt=killed=0;

  t=clock();
  if (argc<3) {
    fprintf(stderr,"Usage: %s pktfile cfgfile",argv[0]);
    exit(1);
  };
  ProcessCfg(argv[2]);
  strcpy(tempname,"TXXXXXX");
  mktemp(tempname);
  if (rename(argv[1],tempname)) {
    perror(argv[1]);
    exit (1);
  };
  if ((f=fopen(tempname,"rb"))==NULL) { perror (argv[1]); exit(1); };
  if ((h=fopen(argv[1],"wb"))==NULL) { perror (argv[1]); exit(1); };
  if (fread (&header,sizeof(header),1,f)<1) {
    perror ("header-read");
    exit(1);
  };
  if (fwrite(&header,sizeof(header),1,h)<1) {
    perror ("pkt-header-write");
    exit(1);
  };
  printf ("\n%s PKTKILL Processing packet  : %s, %02d.%02d.%4d %02d:%02d:%02d", time_now(), argv[1], header.day, header.month, header.year, header.hour, header.min, header.sec);
  if (!(buffer=(char *)malloc(MAX_MSGLEN+10))) {
    perror ("\nalloc(msgbuffer)");
    exit(1);
  };
  do {
    if (fread(&msghdr,sizeof(msghdr),1,f)<1) break;
    multi=0;
    if (msghdr.flag!=2) break;
#ifdef DEBUG
    printf("\n");
#endif
    if (UntilNull(To,37,f)) {
      perror("read-subj");
      exit(1);
    };
#ifdef DEBUG
    printf("\n");
#endif
    if (UntilNull(From,37,f)) {
      perror("read-from");
      exit(1);
    };
#ifdef DEBUG
    printf("\n");
#endif
    if (UntilNull(Subject,73,f)) {
      perror("read-subj");
      exit(1);
    };
#ifdef DEBUG
    printf ("%s %s  %s\n",From, To, Subject);
#endif
    multi=UntilNull(buffer,MAX_MSGLEN,f);
    i=0;
    while ((*(buffer+i)!=1) && (*(buffer+i)!=13)) temp[i]=*(buffer+i++);
    temp[i]=0;
    area[0]=0;
    sscanf(temp,"AREA:%s",area);

    pisi=1;
    never=0;
    nonoarea=0;
    msgcnt++;

    if (area[0]) {
      for (i=0; i<how_many && !nonoarea; i++) 
        if (kill[i].flag==7 && !stricmp(area,kill[i].area)) nonoarea=1;
      
      if (!nonoarea) {
        for (i=0;(i<how_many) && pisi && !never;i++) {
          isarea=0;
          if (!strcmp(kill[i].area,"*")) isarea=1; else isarea=!strcmp(kill[i].area,area);
          if (isarea) switch (kill[i].flag) {
          case 0: pisi = stricmp(kill[i].what,From); break;
          case 1: pisi = stricmp(kill[i].what,To); break;
          case 2: pisi = stricmp(kill[i].what,Subject); break;
          case 3: pisi = !(isarea && stricmp(kill[i].what,From)); break;
          case 4: pisi = !(isarea && stricmp(kill[i].what,To)); break;
          case 5: pisi = !(isarea && stricmp(kill[i].what,Subject)); break;
          case 6: if (!stricmp(kill[i].what,To)) { never=1; pisi=1;}; break;
          };
        };
      };
      rule=i;
    };
    if (pisi) {
      if (fwrite(&msghdr,sizeof(msghdr),1,h)<1) {
        perror ("msgheaderwrite");
        exit(1);
      };
      pos=To;
      while (*pos) fputc(*pos++,h);
      fputc(0,h);
      pos=From;
      while (*pos) fputc(*pos++,h);
      fputc(0,h);
      pos=Subject;
      while (*pos) fputc(*pos++,h);
      fputc(0,h);
#ifdef DEBUG
      printf(".");
#endif
      i=0;
      while (*(buffer+i) && i<=MAX_MSGLEN) fputc(*(buffer + i++),h);
      while (multi)
      {
        multi=UntilNull(buffer,MAX_MSGLEN,f);
        i=0;
        while (*(buffer+i) && i<=MAX_MSGLEN) fputc(*(buffer + i++),h);
      };
      fputc(0,h);
    } else {
      printf("\n%s PKTKILL Killed %s: %s to %s Subj:%s by rule: %d",time_now(),area,From,To,Subject,rule);
      killed++;
    };
  } while (!feof(f));
  fclose(f);
  fputc(0,h);
  fputc(0,h);
  fclose(h);
  unlink(tempname);
  t=clock()-t;
  printf("\n%s PKTKILL Killed: %d/%d in %ds",time_now(),killed,msgcnt,(int)(t/CLK_TCK));
  return 0;
};
